// Copyright 2011 Google Inc. All Rights Reserved.

/**
 * @fileoverview Description of this file.
 * @author mschilder@google.com (Marius Schilder)
 */

var SSH2_MSG_DISCONNECT = 1;
var SSH2_MSG_IGNORE = 2;
var SSH2_MSG_UNIMPLEMENTED = 3;
var SSH2_MSG_DEBUG = 4;
var SSH2_MSG_SERVICE_REQUEST = 5;
var SSH2_MSG_SERVICE_ACCEPT = 6;

var SSH2_MSG_KEYINIT = 20;
var SSH2_MSG_NEWKEYS = 21;

var SSH2_MSG_KEXDH_INIT = 30;
var SSH2_MSG_KEXDH_REPLY = 31;

var SSH2_MSG_USERAUTH_REQUEST = 50;        // 0x32
var SSH2_MSG_USERAUTH_FAILURE = 51;        // 0x33
var SSH2_MSG_USERAUTH_SUCCESS = 52;        // 0x34
var SSH2_MSG_USERAUTH_BANNER = 53;         // 0x35

var SSH2_MSG_USERAUTH_INFO_REQUEST = 60;   // 0x3c
var SSH2_MSG_USERAUTH_INFO_RESPONSE = 61;  // 0x3d

var SSH2_MSG_GLOBAL_REQUEST = 80;          // 0x50
var SSH2_MSG_REQUEST_SUCCESS = 81;         // 0x51
var SSH2_MSG_REQUEST_FAILURE = 82;         // 0x52

var SSH2_MSG_CHANNEL_OPEN = 90;
var SSH2_MSG_CHANNEL_OPEN_CONFIRMATION = 91;
var SSH2_MSG_CHANNEL_OPEN_FAILURE = 92;
var SSH2_MSG_CHANNEL_WINDOW_ADJUST = 93;
var SSH2_MSG_CHANNEL_DATA = 94;
var SSH2_MSG_CHANNEL_EXTENDED_DATA = 95;
var SSH2_MSG_CHANNEL_EOF = 96;             // 0x60
var SSH2_MSG_CHANNEL_CLOSE = 97;           // 0x61
var SSH2_MSG_CHANNEL_REQUEST = 98;         // 0x62
var SSH2_MSG_CHANNEL_SUCCESS = 99;         // 0x63
var SSH2_MSG_CHANNEL_FAILURE = 100;        // 0x64

// ssh-agent commands we care about.
var SSH2_AGENTC_REQUEST_IDENTITIES = 11;    // 0x0b
var SSH2_AGENT_IDENTITIES_ANSWER = 12;      // 0x0c
var SSH2_AGENTC_SIGN_REQUEST = 13;          // 0x0d
var SSH2_AGENT_SIGN_RESPONSE = 14;          // 0x0e

var SSH2_AGENTC_REQUEST_GNUBBY = 100;       // 0x64

var SSH2_AGENTC_GNUBBY_SIGN_REQUEST = 101;  // 0x65
var SSH2_AGENT_GNUBBY_SIGN_RESPONSE = 102;  // 0x66

var SSH2_AGENTC_ECREDS_READ = 110;
var SSH2_AGENT_ECREDS_READ_ANSWER = 111;
var SSH2_AGENTC_ECREDS_WRITE = 112;

var SSH2_AGENTC_PK_CHALLENGE = 113;
var SSH2_AGENT_PK_RESPONSE = 114;

var SSH2_AGENTC_CERT_WRITE = 115;
var SSH2_AGENTC_CERT_READ = 116;
var SSH2_AGENT_CERT_READ_ANSWER = 117;

var SSH2_AGENT_SET_EMERGENCY = 118;
var SSH2_AGENTC_GNUBBY_GET_VERSION = 119;
var SSH2_AGENT_GNUBBY_GET_VERSION_ANSWER = 120;

// generic response codes.
var SSH2_AGENT_FAILURE = 5;
var SSH2_AGENT_SUCCESS = 6;
