/// <reference path='../../../third_party/freedom-typings/freedom-common.d.ts' />
/// <reference path='../../../third_party/freedom-typings/freedom-module-env.d.ts' />
/// <reference path='../../../third_party/freedom-typings/tcp-socket.d.ts' />
/// <reference path='../../../third_party/typings/jasmine/jasmine.d.ts' />
var freedomMocker = require('../../../third_party/uproxy-lib/freedom/mocks/mock-freedom-in-module-env');
freedom = freedomMocker.makeMockFreedomInModuleEnv();
var tcp = require('./tcp');
describe('Tcp', function () {
    it('conversion of a connected endpoint info', function () {
        var input = {
            localAddress: '127.0.0.1',
            localPort: 1234,
            peerAddress: '192.0.2.111',
            peerPort: 1023,
            connected: true
        };
        var output = {
            bound: {
                address: '127.0.0.1',
                port: 1234
            },
            remote: {
                address: '192.0.2.111',
                port: 1023
            }
        };
        expect(tcp.endpointOfSocketInfo(input)).toEqual(output);
    });
    it('conversion of a closed endpoint info', function () {
        var input = {
            connected: false
        };
        var output = {};
        expect(tcp.endpointOfSocketInfo(input)).toEqual(output);
    });
});
