/// <reference path='../../../../third_party/freedom-typings/freedom-module-env.d.ts' />
/// <reference path='../../../../third_party/freedom-typings/rtcpeerconnection.d.ts' />
var logging = require('../../logging/logging');
var loggingTypes = require('../../loggingprovider/loggingprovider.types');
var peerconnection = require('../../webrtc/peerconnection');
exports.loggingController = freedom['loggingcontroller']();
exports.loggingController.setDefaultFilter(0 /* console */, 0 /* debug */);
exports.loggingController.setDefaultFilter(1 /* buffered */, 0 /* debug */);
exports.moduleName = 'copypaste-socks';
exports.log = new logging.Log(exports.moduleName);
var pcConfig = {
    iceServers: [{ urls: ['stun:stun.l.google.com:19302'] }, { urls: ['stun:stun1.l.google.com:19302'] }]
};
exports.parentModule = freedom();
function connectDataChannel(d) {
    d.dataFromPeerQueue.setSyncHandler(function (data) {
        exports.parentModule.emit('messageFromPeer', data.str);
    });
    exports.parentModule.on('messageFromPeer', function (message) {
        d.send({ str: message }).catch(function (e) {
            exports.log.error('error sending chat message: ' + e.message);
        });
    });
}
exports.connectDataChannel = connectDataChannel;
function makePeerConnection() {
    var pc = peerconnection.createPeerConnection(pcConfig);
    pc.signalForPeerQueue.setSyncHandler(function (message) {
        exports.parentModule.emit('signalForPeer', message);
    });
    pc.onceConnected.then(function () {
        exports.log.info(exports.moduleName + ' connected');
    }, function (e) {
        exports.log.error('%1 failed to connect: %2', exports.moduleName, e.message);
    });
    pc.peerOpenedChannelQueue.setSyncHandler(function (d) {
        if (d.getLabel() === 'text') {
            exports.log.info('connected data channel');
            connectDataChannel(d);
            exports.parentModule.emit('ready');
        }
        else {
            exports.log.info('ignored created data channel: ' + d.getLabel());
        }
    });
    return pc;
}
exports.makePeerConnection = makePeerConnection;
exports.pc;
exports.parentModule.on('start', function () {
    exports.pc = makePeerConnection();
    exports.pc.negotiateConnection().then(function () {
        return exports.pc.openDataChannel('text');
    }).then(connectDataChannel).then(function () {
        exports.parentModule.emit('ready');
    }).catch(function (e) {
        exports.log.error('could not negotiate peerconnection: ' + e.message);
    });
});
// Receive signalling channel messages from the UI.
// If pc doesn't exist yet then we are responding to the remote
// peer's initiation.
exports.parentModule.on('signalFromPeer', function (message) {
    if (exports.pc === undefined) {
        exports.pc = makePeerConnection();
    }
    exports.pc.handleSignalMessage(message);
});
