/// <reference path='../../../../third_party/freedom-typings/freedom-common.d.ts' />
/// <reference path='../../../../third_party/freedom-typings/freedom-core-env.d.ts' />
var sendButtonA = document.getElementById("sendButtonA");
var sendButtonB = document.getElementById("sendButtonB");
var sendAreaA = document.getElementById("sendAreaA");
var sendAreaB = document.getElementById("sendAreaB");
var receiveAreaA = document.getElementById("receiveAreaA");
var receiveAreaB = document.getElementById("receiveAreaB");
var stopButton = document.getElementById("stopButton");
freedom('freedom-module.json', {
    'logger': 'uproxy-lib/loggingprovider/freedom-module.json',
    'debug': 'debug'
}).then(function (simpleChatFactory) {
    // TODO: typings for the freedom module
    var chat = simpleChatFactory();
    chat.on('ready', function () {
        sendAreaA.disabled = false;
        sendAreaB.disabled = false;
    });
    chat.on('error', function () {
        sendAreaA.disabled = true;
        sendAreaB.disabled = true;
    });
    function send(suffix, textArea) {
        chat.emit('send' + suffix, {
            message: textArea.value || '(empty message)'
        });
    }
    sendButtonA.onclick = send.bind(null, 'A', sendAreaA);
    sendButtonB.onclick = send.bind(null, 'B', sendAreaB);
    function receive(textArea, msg) {
        textArea.value = msg.message;
    }
    chat.on('receiveA', receive.bind(null, receiveAreaA));
    chat.on('receiveB', receive.bind(null, receiveAreaB));
    stopButton.onclick = function () {
        chat.emit('stop');
    };
}, function (e) {
    console.error('could not load freedom: ' + e.message);
});
