/// <reference path='../../../third_party/typings/es6-promise/es6-promise.d.ts' />
var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
// Basic class to hold event handler functions.
var EventHandlerHolder = (function () {
    function EventHandlerHolder() {
        var _this = this;
        this.handlers = [];
        this.add = function (f) {
            _this.handlers.push(f);
        };
        this.remove = function (f) {
            var index = _this.handlers.indexOf(f);
            if (index > -1) {
                _this.handlers.splice(index, 1);
            }
        };
        this.removeAll = function () {
            _this.handlers = [];
        };
    }
    return EventHandlerHolder;
})();
exports.EventHandlerHolder = EventHandlerHolder;
// Simple Event handler class where the event handler takes an argument T and
// doesn't return anything.
var UnitEventHandler = (function (_super) {
    __extends(UnitEventHandler, _super);
    function UnitEventHandler() {
        var _this = this;
        _super.call(this);
        this.handle = function (x) {
            _this.handlers.forEach(function (f) { return f(x); });
        };
    }
    return UnitEventHandler;
})(EventHandlerHolder);
exports.UnitEventHandler = UnitEventHandler;
// Event handler for when the events return a promise, and when you handle
// something you want all the results.
var PromisedEventHandler = (function (_super) {
    __extends(PromisedEventHandler, _super);
    function PromisedEventHandler() {
        var _this = this;
        _super.call(this);
        this.handle = function (x) {
            var promises = [];
            _this.handlers.forEach(function (f) { return promises.push(f(x)); });
            return Promise.all(promises);
        };
    }
    return PromisedEventHandler;
})(EventHandlerHolder);
exports.PromisedEventHandler = PromisedEventHandler;
