// This enum describes a simple signal message protocol for establishing P2P
// connections. TODO: rename to more accurately describe the intended
// abstraction: namely: INIT, DATA, END
(function (Type) {
    Type[Type["OFFER"] = 0] = "OFFER";
    Type[Type["ANSWER"] = 1] = "ANSWER";
    // Possible candidate types, e.g. RELAY if a host is only accessible
    // via a TURN server. The values are taken from this file; as the comment
    // suggests, not all values may be found in practice:
    //   https://code.google.com/p/chromium/codesearch#chromium/src/third_party/webrtc/p2p/base/port.cc&q=port.cc&l=107
    Type[Type["CANDIDATE"] = 2] = "CANDIDATE";
    Type[Type["NO_MORE_CANDIDATES"] = 3] = "NO_MORE_CANDIDATES"; // no more data to send to peer
})(exports.Type || (exports.Type = {}));
var Type = exports.Type;
