/// <reference path='../../../../third_party/freedom-typings/freedom-common.d.ts' />
var churn = require('../../churn/churn');
var loggingTypes = require('../../../../third_party/uproxy-lib/loggingprovider/loggingprovider.types');
freedom['loggingcontroller']().setDefaultFilter(0 /* console */, 0 /* debug */);
var logging = require('../../../../third_party/uproxy-lib/logging/logging');
var log = new logging.Log('copypaste churn chat');
var config = {
    iceServers: [{ urls: ['stun:stun.l.google.com:19302'] }, { urls: ['stun:stun1.l.google.com:19302'] }]
};
exports.freedomPc = freedom['core.rtcpeerconnection'](config);
exports.pc = new churn.Connection(exports.freedomPc);
exports.freedomParentModule = freedom();
// Forward signalling channel messages to the UI.
exports.pc.signalForPeerQueue.setSyncHandler(function (message) {
    // FIXME: Does signalForPeer want a ChurnSignallingMessage?  How is the stage
    // value supposed to get filled in.
    exports.freedomParentModule.emit('signalForPeer', message);
});
// Receive signalling channel messages from the UI.
exports.freedomParentModule.on('handleSignalMessage', function (message) {
    exports.pc.handleSignalMessage(message);
});
exports.pc.onceConnecting.then(function () {
    log.info('connecting...');
});
exports.connectDataChannel = function (channel) {
    // Send messages over the datachannel, in response to events from the UI,
    // and forward messages received on the datachannel to the UI.
    exports.freedomParentModule.on('send', function (message) {
        channel.send({ str: message }).catch(function (e) {
            log.error('error sending message: ' + e.message);
        });
    });
    channel.dataFromPeerQueue.setSyncHandler(function (d) {
        if (d.str === undefined) {
            log.error('only text messages are supported');
            return;
        }
        exports.freedomParentModule.emit('receive', d.str);
    });
};
// TODO: This is messy...would be great just to have both sides
//       call onceConnected but it doesn't seem to fire :-/
exports.pc.peerOpenedChannelQueue.setSyncHandler(function (channel) {
    log.info('peer opened datachannel!');
    exports.connectDataChannel(channel);
    exports.freedomParentModule.emit('ready', {});
});
// Negotiate a peerconnection.
exports.freedomParentModule.on('start', function () {
    exports.pc.negotiateConnection().then(function () {
        exports.pc.openDataChannel('text').then(function (channel) {
            log.info('datachannel open!');
            exports.connectDataChannel(channel);
            exports.freedomParentModule.emit('ready', {});
        }, function (e) {
            log.error('could not setup datachannel: ' + e.message);
            exports.freedomParentModule.emit('error', {});
        });
    }, function (e) {
        log.error('could not negotiate peerconnection: ' + e.message);
    });
});
