/// <reference path='../../../../third_party/freedom-typings/freedom-common.d.ts' />
/// <reference path='../../../../third_party/freedom-typings/freedom-core-env.d.ts' />
;
;
var startButton = document.getElementById("startButton");
var copyTextarea = document.getElementById("copy");
var pasteTextarea = document.getElementById("paste");
var receiveButton = document.getElementById("receiveButton");
var sendButton = document.getElementById("sendButton");
var sendArea = document.getElementById("sendArea");
var receiveArea = document.getElementById("receiveArea");
exports.copypasteChurnChat;
freedom('freedom-module.json', {
    'logger': 'uproxy-lib/loggingprovider/freedom-module.json',
    'debug': 'debug'
}).then(function (copypasteChurnChatFactory) {
    exports.copypasteChurnChat = copypasteChurnChatFactory();
    // Dispatches each line from the paste box as a signalling channel message.
    function handleSignallingMessages() {
        var signals = pasteTextarea.value.split('\n');
        for (var i = 0; i < signals.length; i++) {
            var s = signals[i];
            // Ignore blank lines.
            if (s) {
                var signal = JSON.parse(s);
                exports.copypasteChurnChat.emit('handleSignalMessage', signal);
            }
        }
        // "Flush" the signalling channel input.
        pasteTextarea.value = '';
    }
    function start() {
        exports.copypasteChurnChat.emit('start', {});
    }
    startButton.onclick = start;
    receiveButton.onclick = handleSignallingMessages;
    exports.copypasteChurnChat.on('signalForPeer', function (signal) {
        copyTextarea.value = copyTextarea.value.trim() + '\n' + JSON.stringify(signal);
    });
    exports.copypasteChurnChat.on('ready', function () {
        console.log('peer connection established!');
        // Hide remaining signalling channel contents.
        copyTextarea.value = '';
        sendArea.disabled = false;
    });
    exports.copypasteChurnChat.on('error', function () {
        console.error('something went wrong with the peer connection');
        sendArea.disabled = true;
    });
    sendButton.onclick = function () {
        // Currently, PeerConnection does not support empty text messages:
        //   https://github.com/freedomjs/freedom/issues/67
        exports.copypasteChurnChat.emit('send', sendArea.value || '(empty message)');
    };
    exports.copypasteChurnChat.on('receive', function (message) {
        receiveArea.value = message;
    });
}, function (e) {
    console.error('could not load freedom: ' + e.message);
});
