/// <reference path='../../../../third_party/typings/es6-promise/es6-promise.d.ts' />
/// <reference path='../../../../third_party/freedom-typings/freedom-common.d.ts' />
/// <reference path='../../../../third_party/freedom-typings/freedom-module-env.d.ts' />
/// <reference path='../../../../third_party/freedom-typings/rtcpeerconnection.d.ts' />
var churn = require('../../churn/churn');
var logging = require('../../../../third_party/uproxy-lib/logging/logging');
// Example of how to configure logging level
// freedom['loggingcontroller']().setDefaultFilter(loggingTypes.Destination.console,
//     loggingTypes.Level.info);
exports.log = new logging.Log('simple churn chat');
var config = {
    iceServers: [{ urls: ['stun:stun.l.google.com:19302'] }, { urls: ['stun:stun1.l.google.com:19302'] }]
};
exports.pcA = freedom['core.rtcpeerconnection'](config);
exports.a = new churn.Connection(exports.pcA);
exports.pcB = freedom['core.rtcpeerconnection'](config);
exports.b = new churn.Connection(exports.pcB);
// Connect the two signalling channels.
// Normally, these messages would be sent over the internet.
exports.a.signalForPeerQueue.setSyncHandler(function (signal) {
    exports.log.info('signalling channel A message: ' + JSON.stringify(signal));
    exports.b.handleSignalMessage(signal);
});
exports.b.signalForPeerQueue.setSyncHandler(function (signal) {
    exports.log.info('signalling channel B message: ' + JSON.stringify(signal));
    exports.a.handleSignalMessage(signal);
});
// Send messages over the datachannel, in response to events from the UI.
var sendMessage = function (channel, message) {
    channel.send({ str: message }).catch(function (e) {
        exports.log.error('error sending message: ' + e.message);
    });
};
// Handle messages received on the datachannel(s).
// The message is forwarded to the UI.
var receiveMessage = function (name, d) {
    if (d.str === undefined) {
        exports.log.error('only text messages are supported');
        return;
    }
    freedom().emit('receive' + name, d.str);
};
exports.b.peerOpenedChannelQueue.setSyncHandler(function (channel) {
    exports.log.info('i can see that `a` created a data channel called ' + channel.getLabel());
    freedom().on('sendB', sendMessage.bind(null, channel));
    channel.dataFromPeerQueue.setHandler(receiveMessage.bind(null, 'B'));
});
exports.a.onceConnecting.then(function () {
    exports.log.info('a is connecting...');
});
exports.b.onceConnecting.then(function () {
    exports.log.info('b is connecting...');
});
// Log the fact that the specified connection is connected.
function logConnected(name) {
    exports.log.info(name + ' connected');
}
exports.a.onceConnected.then(logConnected.bind(null, 'a'));
exports.b.onceConnected.then(logConnected.bind(null, 'b'));
// Negotiate a peerconnection.
// Once negotiated, enable the UI and add send/receive handlers.
exports.a.negotiateConnection().then(function () {
    exports.a.openDataChannel('text').then(function (channel) {
        exports.log.info('datachannel open!');
        freedom().on('sendA', sendMessage.bind(null, channel));
        channel.dataFromPeerQueue.setHandler(receiveMessage.bind(null, 'A'));
        freedom().emit('ready', {});
    }, function (e) {
        exports.log.error('could not setup datachannel: ' + e.message);
        freedom().emit('error', {});
    });
}, function (e) {
    exports.log.error('could not negotiate peerconnection: ' + e.message);
});
