// TODO(ldixon): update to a require-style inclusion.
// e.g.
//  import Transformer = require('uproxy-obfuscators/transformer');
/// <reference path='../../../third_party/uTransformers/utransformers.d.ts' />
/**
 * An obfuscator which employs the Caesar cipher. *This does not provide any
 * real security!* It's intended to help prototype the interface between
 * transport and obfuscation and was chosen because even though it's trivial to
 * implement it still requires some configuration.
 */
var CaesarCipher = (function () {
    function CaesarCipher() {
        var _this = this;
        /**
         * Caesar cipher requires just one parameter: the value by which to shift
         * each byte. key should be an ArrayBuffer of just one byte, the value of
         * which will be used for the shift amount (the byte is interpreted as
         * an unsigned integer, so negative shift is not possible).
         */
        this.setKey = function (key) {
            if (key.byteLength != 1) {
                throw new Error('key must be one byte in length');
            }
            var bytes = new Uint8Array(key);
            _this.shift_ = bytes[0];
        };
        /** Nothing to configure -- all this transformer needs is a key. */
        this.configure = function (json) {
        };
        this.transform = function (buffer) {
            _this.map_(buffer, _this.transformByte);
            return buffer;
        };
        this.restore = function (buffer) {
            _this.map_(buffer, _this.restoreByte);
            return buffer;
        };
        // No-op (we have no state or any resources to dispose).
        this.dispose = function () {
        };
        /** Applies mapper to each byte of buffer. */
        this.map_ = function (buffer, mapper) {
            var bytes = new Uint8Array(buffer);
            for (var i = 0; i < bytes.length; i++) {
                bytes[i] = mapper(bytes[i]);
            }
        };
        // Public for testing.
        this.transformByte = function (i) {
            return (i + _this.shift_) % 256;
        };
        // Public for testing.
        this.restoreByte = function (i) {
            i -= _this.shift_;
            if (i < 0) {
                i += 256;
            }
            return i % 256;
        };
    }
    return CaesarCipher;
})();
module.exports = CaesarCipher;
