/// <reference path="../../../../third_party/typings/es6-promise/es6-promise.d.ts" />
/// <reference path="../../../../third_party/freedom-typings/console.d.ts" />
/// <reference path="../../../../third_party/freedom-typings/freedom-common.d.ts" />
import freedomTypes = require('freedom.types');
export declare class MockModuleSelfConstructor implements freedomTypes.ModuleSelfConstructor {
    provideSynchronous(classFn: Function): void;
    provideAsynchronous(classFn: Function): void;
    providePromises(classFn: Function): void;
}
export declare class MockParentModuleThing extends MockModuleSelfConstructor implements freedomTypes.ParentModuleThing {
    on(t: string, f: Function): void;
    emit(t: string, x: any): void;
}
export declare class MockFreedomCore implements freedomTypes.Core {
    getLogger(loggerName: string): Promise<freedomTypes.Logger>;
    createChannel(): Promise<freedomTypes.ChannelSpecifier>;
    bindChannel(channelIdentifier: string): Promise<freedomTypes.Channel>;
    getId(): Promise<string[]>;
}
export declare class MockFreedomConsole implements freedom_Console.Console {
    log(source: string, message: string): Promise<void>;
    debug(source: string, message: string): Promise<void>;
    info(source: string, message: string): Promise<void>;
    warn(source: string, message: string): Promise<void>;
    error(source: string, message: string): Promise<void>;
}
export declare function makeMockFreedomInModuleEnv(providerFactories?: {
    [name: string]: Function;
}): freedomTypes.FreedomInModuleEnv;
