/// <reference path="../../../../third_party/typings/es6-promise/es6-promise.d.ts" />
/// <reference path="../../../../third_party/freedom-typings/freedom-common.d.ts" />
/// <reference path="../../../../third_party/freedom-typings/rtcpeerconnection.d.ts" />
import RTCConfiguration = freedom_RTCPeerConnection.RTCConfiguration;
import RTCDataChannelInit = freedom_RTCPeerConnection.RTCDataChannelInit;
import RTCIceCandidate = freedom_RTCPeerConnection.RTCIceCandidate;
import RTCOfferOptions = freedom_RTCPeerConnection.RTCOfferOptions;
import RTCPeerConnection = freedom_RTCPeerConnection.RTCPeerConnection;
import RTCSessionDescription = freedom_RTCPeerConnection.RTCSessionDescription;
import MockEventHandler = require('./mock-eventhandler');
declare class MockFreedomRtcPeerConnection extends MockEventHandler implements RTCPeerConnection {
    constructor();
    createOffer(options?: RTCOfferOptions): Promise<RTCSessionDescription>;
    createAnswer(): Promise<RTCSessionDescription>;
    setLocalDescription(desc: RTCSessionDescription): Promise<void>;
    getLocalDescription(): Promise<RTCSessionDescription>;
    setRemoteDescription(desc: RTCSessionDescription): Promise<void>;
    getRemoteDescription(): Promise<RTCSessionDescription>;
    getSignalingState(): Promise<string>;
    updateIce(configuration: RTCConfiguration): Promise<void>;
    addIceCandidate(candidate: RTCIceCandidate): Promise<void>;
    getIceGatheringState(): Promise<string>;
    getIceConnectionState(): Promise<string>;
    getConfiguration(): Promise<RTCConfiguration>;
    getLocalStreams(): Promise<string[]>;
    getRemoteStreams(): Promise<string[]>;
    getStreamById(id: string): Promise<string>;
    addStream(ref: string): Promise<void>;
    removeStream(ref: string): Promise<void>;
    close(): Promise<void>;
    createDataChannel(label: string, init: RTCDataChannelInit): Promise<string>;
    getStats(selector?: string): Promise<any>;
}
export = MockFreedomRtcPeerConnection;
