/// <reference path="../../../third_party/typings/es6-promise/es6-promise.d.ts" />
export interface FunctionOf1Arg<T, T2> {
    (x: T): T2;
}
export interface EventHandler<T, T2, T3> {
    add: (f: (x: T) => T2) => void;
    remove: (f: (x: T) => T2) => void;
    removeAll: () => void;
    handle: (x: T) => T3;
}
export declare class EventHandlerHolder<T, T2> {
    constructor();
    handlers: FunctionOf1Arg<T, T2>[];
    add: (f: (x: T) => T2) => void;
    remove: (f: (x: T) => T2) => void;
    removeAll: () => void;
}
export declare class UnitEventHandler<T> extends EventHandlerHolder<T, void> implements EventHandler<T, void, void> {
    constructor();
    handle: (x: T) => void;
}
export declare class PromisedEventHandler<T, T2> extends EventHandlerHolder<T, Promise<T2>> implements EventHandler<T, Promise<T2>, Promise<T2[]>> {
    constructor();
    handle: (x: T) => Promise<T2[]>;
}
