/// <reference path="../../../third_party/typings/es6-promise/es6-promise.d.ts" />
export interface QueueFeeder<Feed, Result> {
    getLength(): number;
    handle(x: Feed): Promise<Result>;
}
export declare class HandlerQueueStats {
    total_events: number;
    queued_events: number;
    immediately_handled_events: number;
    queued_handled_events: number;
    rejected_events: number;
    handler_set_count: number;
    handler_change_count: number;
    handler_clear_count: number;
    handler_rejections: number;
}
export interface QueueHandler<Feed, Result> {
    clear(): void;
    getLength(): number;
    setHandler(f: (x: Feed) => Promise<Result>): void;
    setSyncHandler(f: (x: Feed) => Result): void;
    setNextHandler(f: (x: Feed) => Promise<Result>): Promise<Result>;
    setSyncNextHandler(f: (x: Feed) => Result): Promise<Result>;
    isHandling(): boolean;
    stopHandling(): void;
    getStats(): HandlerQueueStats;
}
export declare class Queue<Feed, Result> implements QueueFeeder<Feed, Result>, QueueHandler<Feed, Result> {
    private queue_;
    private handler_;
    private rejectFn_;
    private stats_;
    constructor();
    getLength: () => number;
    isHandling: () => boolean;
    getStats: () => HandlerQueueStats;
    handle: (x: Feed) => Promise<Result>;
    private processQueue_;
    clear: () => void;
    setHandler: (handler: (x: Feed) => Promise<Result>) => void;
    setSyncHandler: (handler: (x: Feed) => Result) => void;
    stopHandling: () => void;
    setNextHandler: (handler: (x: Feed) => Promise<Result>) => Promise<Result>;
    setSyncNextHandler: (handler: (x: Feed) => Result) => Promise<Result>;
}
