/// <reference path="../../../third_party/freedom-typings/console.d.ts" />
/// <reference path="../../../third_party/freedom-typings/freedom-common.d.ts" />
/// <reference path="../../../third_party/freedom-typings/freedom-module-env.d.ts" />
import logging = require('./loggingprovider.types');
export declare var freedomConsole: freedom_Console.Console;
export declare var MAX_BUFFERED_LOG: number;
export declare var logBuffer: logging.Message[];
export declare var enabled: boolean;
export declare class AbstractLoggingDestination {
    private default_;
    private filters_;
    constructor(default_: logging.Level);
    getLevelForTag: (tag: string) => logging.Level;
    private checkFilter_;
    protected log_: (level: logging.Level, tag: string, message: logging.Message) => void;
    log: (level: logging.Level, tag: string, message: logging.Message) => void;
    private doFilterChanges_;
    setDefaultFilter: (level: logging.Level) => void;
    setFilters: (filters: {
        [tag: string]: logging.Level;
    }) => void;
    setFilter: (tag: string, level?: logging.Level) => void;
}
export declare class ConsoleLoggingDestination extends AbstractLoggingDestination {
    constructor();
    protected log_: (level: logging.Level, tag: string, message: logging.Message) => void;
    private formatMessage_;
}
export declare class BufferedLoggingDestination extends AbstractLoggingDestination {
    constructor();
    protected log_: (level: logging.Level, tag: string, message: logging.Message) => void;
}
export declare class Log implements logging.Log {
    private log_;
    debug: (source: string, msg: string) => void;
    info: (source: string, msg: string) => void;
    log: (source: string, msg: string) => void;
    warn: (source: string, msg: string) => void;
    error: (source: string, msg: string) => void;
}
export declare class LoggingController implements logging.Controller {
    getEncrypedLogBuffer: (tags: string[]) => ArrayBuffer;
    getLogs: (tags?: string[]) => string[];
    private formatMessage_(l);
    clearLogs: () => void;
    enable: () => void;
    disable: () => void;
    setDefaultFilter: (destination: logging.Destination, level: logging.Level) => void;
    setFilters: (destination: logging.Destination, filters: {
        [tag: string]: logging.Level;
    }) => void;
    setFilter: (destination: logging.Destination, tag: string, level?: logging.Level) => void;
}
export declare class LoggingListener implements logging.Listener {
    private dispatchEvent_;
    private tag_;
    constructor(dispatchEvent_: (name: string, data: Object) => void, tag_: string);
    update: () => void;
}
