export interface Message {
    timestamp: Date;
    level: Level;
    tag: string;
    message: string;
}
export interface Log {
    debug(source: string, msg: string): void;
    info(source: string, msg: string): void;
    log(source: string, msg: string): void;
    warn(source: string, msg: string): void;
    error(source: string, msg: string): void;
}
export interface Controller {
    getEncrypedLogBuffer(tags: string[]): ArrayBuffer;
    getLogs(tags?: string[]): string[];
    clearLogs(): void;
    enable(): void;
    disable(): void;
    setDefaultFilter(destination: Destination, level: Level): void;
    setFilters(destination: Destination, filters: {
        [tag: string]: Level;
    }): void;
    setFilter(destination: Destination, tag: string, level?: Level): void;
}
export interface Listener {
}
export declare enum Level {
    debug = 0,
    info = 1,
    warn = 2,
    error = 3,
}
export declare enum Destination {
    console = 0,
    buffered = 1,
}
