/// <reference path="../../../third_party/typings/es6-promise/es6-promise.d.ts" />
/// <reference path="../../../third_party/freedom-typings/rtcdatachannel.d.ts" />
/// <reference path="../../../third_party/freedom-typings/freedom-common.d.ts" />
import handler = require('../handler/queue');
export declare var PC_QUEUE_LIMIT: number;
export interface DataChannel {
    getLabel: () => string;
    onceOpened: Promise<void>;
    onceClosed: Promise<void>;
    dataFromPeerQueue: handler.QueueHandler<Data, void>;
    send(data: Data): Promise<void>;
    getBrowserBufferedAmount(): Promise<number>;
    getJavascriptBufferedAmount(): number;
    isInOverflow(): boolean;
    setOverflowListener(listener: (overflow: boolean) => void): void;
    close(): Promise<void>;
    toString(): string;
}
export interface Data {
    str?: string;
    buffer?: ArrayBuffer;
}
export declare class DataChannelClass implements DataChannel {
    private rtcDataChannel_;
    private label_;
    dataFromPeerQueue: handler.Queue<Data, void>;
    private toPeerDataQueue_;
    private toPeerDataBytes_;
    private lastBrowserBufferedAmount_;
    onceOpened: Promise<void>;
    onceClosed: Promise<void>;
    private draining_;
    private fulfillDrained_;
    private onceDrained_;
    private isOpen_;
    private rejectOpened_;
    private overflow_;
    private overflowListener_;
    getLabel: () => string;
    constructor(rtcDataChannel_: freedom_RTCDataChannel.RTCDataChannel, label_?: string);
    private onDataFromPeer_;
    send: (data: Data) => Promise<void>;
    private chunkStringOntoQueue_;
    private chunkBufferOntoQueue_;
    private handleSendDataToPeer_;
    private setOverflow_;
    private conjestionControlSendHandler;
    close: () => Promise<void>;
    private waitForBrowserToDrain_;
    getBrowserBufferedAmount: () => Promise<number>;
    getJavascriptBufferedAmount: () => number;
    isInOverflow: () => boolean;
    setOverflowListener: (listener: (overflow: boolean) => void) => void;
    toString: () => string;
    setLabel: (label: string) => void;
}
export declare function createFromFreedomId(id: string): Promise<DataChannel>;
export declare function createFromRtcDataChannel(rtcDataChannel: freedom_RTCDataChannel.RTCDataChannel): Promise<DataChannel>;
