/// <reference path="../../../third_party/typings/es6-promise/es6-promise.d.ts" />
/// <reference path="../../../third_party/freedom-typings/rtcpeerconnection.d.ts" />
/// <reference path="../../../third_party/freedom-typings/freedom-common.d.ts" />
import handler = require('../handler/queue');
import datachannel = require('./datachannel');
import signals = require('./signals');
export interface DataChannel extends datachannel.DataChannel {
}
export interface Data extends datachannel.Data {
}
export declare enum State {
    WAITING = 0,
    CONNECTING = 1,
    CONNECTED = 2,
    DISCONNECTED = 3,
}
export interface PeerConnection<TSignallingMessage> {
    pcState: State;
    dataChannels: {
        [channelLabel: string]: DataChannel;
    };
    onceConnecting: Promise<void>;
    onceConnected: Promise<void>;
    onceDisconnected: Promise<void>;
    negotiateConnection: () => Promise<void>;
    openDataChannel: (channelLabel: string, options?: freedom_RTCPeerConnection.RTCDataChannelInit) => Promise<DataChannel>;
    peerOpenedChannelQueue: handler.QueueHandler<DataChannel, void>;
    handleSignalMessage: (message: TSignallingMessage) => void;
    signalForPeerQueue: handler.QueueHandler<TSignallingMessage, void>;
    close: () => Promise<void>;
}
export declare class PeerConnectionClass implements PeerConnection<signals.Message> {
    private pc_;
    peerName_: string;
    private static HEARTBEAT_TIMEOUT_MS_;
    private static HEARTBEAT_INTERVAL_MS_;
    private static HEARTBEAT_MESSAGE_;
    static peerConnections: {
        [name: string]: PeerConnection<signals.Message>;
    };
    dataChannels: {
        [channelLabel: string]: DataChannel;
    };
    pcState: State;
    onceConnecting: Promise<void>;
    onceConnected: Promise<void>;
    onceDisconnected: Promise<void>;
    peerOpenedChannelQueue: handler.Queue<DataChannel, void>;
    signalForPeerQueue: handler.Queue<signals.Message, void>;
    fromPeerCandidateQueue: handler.Queue<freedom_RTCPeerConnection.RTCIceCandidate, void>;
    private fulfillConnecting_;
    private fulfillConnected_;
    private rejectConnected_;
    private fulfillDisconnected_;
    private controlDataChannel_;
    private static CONTROL_CHANNEL_LABEL;
    private static automaticNameIndex_;
    constructor(pc_: freedom_RTCPeerConnection.RTCPeerConnection, peerName_?: string);
    close: () => Promise<void>;
    private closeWithError_;
    private onSignallingStateChange_;
    private onIceConnectionStateChange_;
    private completeConnection_;
    negotiateConnection: () => Promise<void>;
    private onNegotiationNeeded_;
    private breakOfferTie_;
    private handleOfferSignalMessage_;
    private handleAnswerSignalMessage_;
    private handleCandidateSignalMessage_;
    private emitSignalForPeer_;
    handleSignalMessage: (message: signals.Message) => void;
    openDataChannel: (channelLabel: string, options?: freedom_RTCPeerConnection.RTCDataChannelInit) => Promise<DataChannel>;
    private onPeerStartedDataChannel_;
    private addRtcDataChannel_;
    private registerControlChannel_;
    private initiateHeartbeat_;
    toString: () => string;
}
export declare function createPeerConnection(config: freedom_RTCPeerConnection.RTCConfiguration, debugPcName?: string): PeerConnection<signals.Message>;
